=== source/modules/Makefile ===
#!/usr/bin/make -f
# Makefile for carla modules #
# -------------------------- #
# Created by falkTX
#

# ----------------------------------------------------------------------------------------------------------------------------

all:

clean:
	$(MAKE) clean -C audio_decoder
	$(MAKE) clean -C dgl
	$(MAKE) clean -C lilv
	$(MAKE) clean -C rtaudio
	$(MAKE) clean -C rtmempool
	$(MAKE) clean -C rtmidi
	$(MAKE) clean -C sfzero
	$(MAKE) clean -C water

# ----------------------------------------------------------------------------------------------------------------------------
