=== debian/changelog ===
carla (2.0.0-0ubuntu2) eoan; urgency=medium

  * Remove qt4 dependencies
  * Specify architectures

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Thu, 22 Aug 2019 18:56:14 -0500

carla (2.0.0-0ubuntu1) disco; urgency=medium

  [Erich Eickmeyer]
  * New Upstream Release 2.0.0

 -- Erich Eickmeyer <erich@ericheickmeyer.com>  Sun, 17 Mar 2019 15:44:56 -0700
